//
// $Id: test_i.cpp 76555 2007-01-24 15:39:09Z johnnyw $
//
#include "test_i.h"
#include "ace/OS_NS_unistd.h"

test_i::test_i (ORB_Killer *k)
  : killer_ (k)
{
}

void
test_i::ping (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{

}

void
test_i::shutdown (void)
  ACE_THROW_SPEC ((CORBA::SystemException))
{
  ACE_DEBUG ((LM_DEBUG,"(%P|%t) requesting shutdown \n"));
  this->killer_->activate ();
}


ORB_Killer::ORB_Killer (CORBA::ORB_ptr orb)
  : orb_ (CORBA::ORB::_duplicate (orb))
{
}

int
ORB_Killer::svc ()
{
  ACE_OS::sleep (1);
  ACE_DEBUG ((LM_DEBUG,"(%P|%t) doing shutdown \n"));
  orb_->shutdown(1);
  ACE_DEBUG ((LM_DEBUG,"(%P|%t) shutdown complete\n"));
  return 0;
}
